# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Functions

* [`bodgitlib::enclose_ipv6`](#bodgitlibenclose_ipv6)

### Data types

* [`Bodgitlib::Domain`](#bodgitlibdomain)
* [`Bodgitlib::Host`](#bodgitlibhost)
* [`Bodgitlib::Hostname`](#bodgitlibhostname)
* [`Bodgitlib::LDAP::DN`](#bodgitlibldapdn)
* [`Bodgitlib::LDAP::Filter`](#bodgitlibldapfilter)
* [`Bodgitlib::LDAP::Scope`](#bodgitlibldapscope)
* [`Bodgitlib::LDAP::URI::LDAP::Simple`](#bodgitlibldapurildapsimple)
* [`Bodgitlib::LDAP::URI::LDAPI::Simple`](#bodgitlibldapurildapisimple)
* [`Bodgitlib::LDAP::URI::LDAPS::Simple`](#bodgitlibldapurildapssimple)
* [`Bodgitlib::LDAP::URI::Simple`](#bodgitlibldapurisimple)
* [`Bodgitlib::Netmask`](#bodgitlibnetmask)
* [`Bodgitlib::Port`](#bodgitlibport)
* [`Bodgitlib::Port::Ephemeral`](#bodgitlibportephemeral)
* [`Bodgitlib::Port::Privileged`](#bodgitlibportprivileged)
* [`Bodgitlib::Port::Registered`](#bodgitlibportregistered)
* [`Bodgitlib::Zone`](#bodgitlibzone)
* [`Bodgitlib::Zone::NonRoot`](#bodgitlibzonenonroot)
* [`Bodgitlib::Zone::Root`](#bodgitlibzoneroot)

## Functions

### `bodgitlib::enclose_ipv6`

Type: Puppet Language

The bodgitlib::enclose_ipv6 function.

#### `bodgitlib::enclose_ipv6(String $host)`

The bodgitlib::enclose_ipv6 function.

Returns: `Any`

##### `host`

Data type: `String`



## Data types

### `Bodgitlib::Domain`

The Bodgitlib::Domain data type.

* **Since** 1.5.0

Alias of `Pattern[/(?x) ^ (?= [a-z0-9.-]{2,255} ) ( (?= [a-z0-9-]{1,63} \. ) [a-z0-9]+ ( - [a-z0-9]+ )* \. )* [a-z]{2,63} $/]`

### `Bodgitlib::Host`

The Bodgitlib::Host data type.

* **Since** 1.7.0

Alias of `Variant[Bodgitlib::Hostname, Stdlib::IP::Address::NoSubnet]`

### `Bodgitlib::Hostname`

The Bodgitlib::Hostname data type.

* **Since** 1.6.0

Alias of `Bodgitlib::Domain`

### `Bodgitlib::LDAP::DN`

The Bodgitlib::LDAP::DN data type.

* **Since** 1.5.0

Alias of `Pattern[/(?x) ^ (?<comp> (?<tv> (?: [[:alpha:]] [[:alnum:]_-]* | (?: (?: oid | OID ) \. )? [[:digit:]]+ (?: \. [[:digit:]]+ )* ) [[:space:]]* = [[:space:]]* (?: \# (?: [[:xdigit:]]{2} )+ | (?: [^,=\+<>#;\\"] | \\ [,=\+<>#;\\"] | \\ [[:xdigit:]]{2} )* | " (?: [^\\"] | \\ [,=\+<>#;\\"] | \\ [[:xdigit:]]{2} )* " ) ) (?: [[:space:]]* \+ [[:space:]]* \g<tv> )* ) (?: [[:space:]]* [,;] [[:space:]]* \g<comp> )* $/]`

### `Bodgitlib::LDAP::Filter`

The Bodgitlib::LDAP::Filter data type.

* **Since** 1.5.0

Alias of `Pattern[/(?x) ^ (?<re> \( (?: [&|] \g<re>+ | ! \g<re> | (?: (?<attr> (?: [[:alpha:]] [[:alnum:]_-]* | [[:digit:]]+ (?: \. [[:digit:]]+ )* ) (?: ; [[:alpha:]] [[:alnum:]-]* )* ) [~<>]? = (?<value> (?: [^\\()*] | \\ [[:xdigit:]]{2} )* ) | \g<attr> = \* | \g<attr> = \g<value>? \* (?: \g<value> \* )* \g<value>? | (?: \g<attr> (?: :dn )? (?: : (?<rule> [[:digit:]]+ (?: \. [[:digit:]]+ )* | [[:alpha:]] [[:alnum:]]* Match ) )? := \g<value> | (?: : (?: dn | DN ) )? : \g<rule> := \g<value> ) ) ) \) ) $/]`

### `Bodgitlib::LDAP::Scope`

The Bodgitlib::LDAP::Scope data type.

* **Since** 1.6.0

Alias of `Enum['sub', 'one', 'base']`

### `Bodgitlib::LDAP::URI::LDAP::Simple`

The Bodgitlib::LDAP::URI::LDAP::Simple data type.

* **Since** 1.6.0

Alias of `Pattern[/(?x) ^ ldap:\/\/ (?: (?= [a-z0-9.-]{2,255} ) (?: (?= [a-z0-9-]{1,63} \. ) [a-z0-9]+ (?: - [a-z0-9]+ )* \. )* [a-z]{2,63} | (?<ipv4> (?<octet> [0-9] | [1-9][0-9] | 1[0-9]{2} | 2[0-4][0-9] | 25[0-5] ) (?: \. \g<octet> ){3} ) | \[ (?: (?<short> [[:xdigit:]]{1,4} ) (?: : \g<short> ){7} | (?: : (?: : | (?: : \g<short> ){1,7} ) | \g<short> : (?: : | (?: : \g<short> ){1,6} ) | (?: \g<short> : ){2} (?: : | (?: : \g<short> ){1,5} ) | (?: \g<short> : ){3}  (?: : | (?: : \g<short> ){1,4} ) | (?: \g<short> : ){4} (?: : | (?: : \g<short> ){1,3} ) | (?: \g<short> : ){5} (?: : | (?: : \g<short> ){1,2} ) | (?: \g<short> : ){6} (?: : | (?: : \g<short> ) ) | (?: \g<short> : ){7} : ) | (?: (?: \g<short> : ){6} \g<ipv4> | (?: \g<short> : ){5} : \g<ipv4> | (?: \g<short> : ){4} (?: : \g<short> )? : \g<ipv4> | (?: \g<short> : ){3} (?: : \g<short> ){0,2} : \g<ipv4> | (?: \g<short> : ){2} (?: : \g<short> ){0,3} : \g<ipv4> | \g<short> : (?: : \g<short> ){0,4} : \g<ipv4> | : (?: : \g<short> ){0,5} : \g<ipv4> ) ) \] )? (?: : (?: [1-9][0-9]{0,3} | [1-5][0-9]{4} | 6[0-4][0-9]{3} | 65[0-4][0-9]{2} | 655[0-2][0-9] | 6553[0-5] ) )? \/? $/]`

### `Bodgitlib::LDAP::URI::LDAPI::Simple`

The Bodgitlib::LDAP::URI::LDAPI::Simple data type.

* **Since** 1.6.0

Alias of `Pattern[/(?x) ^ ldapi:\/\/ (?: (?= [a-zA-Z0-9.%_-]{2,255} ) (?: [a-zA-Z0-9._-] | % [[:xdigit:]]{2} )+ )? \/? $/]`

### `Bodgitlib::LDAP::URI::LDAPS::Simple`

The Bodgitlib::LDAP::URI::LDAPS::Simple data type.

* **Since** 1.6.0

Alias of `Pattern[/(?x) ^ ldaps:\/\/ (?: (?= [a-z0-9.-]{2,255} ) (?: (?= [a-z0-9-]{1,63} \. ) [a-z0-9]+ (?: - [a-z0-9]+ )* \. )* [a-z]{2,63} | (?<ipv4> (?<octet> [0-9] | [1-9][0-9] | 1[0-9]{2} | 2[0-4][0-9] | 25[0-5] ) (?: \. \g<octet> ){3} ) | \[ (?: (?<short> [[:xdigit:]]{1,4} ) (?: : \g<short> ){7} | (?: : (?: : | (?: : \g<short> ){1,7} ) | \g<short> : (?: : | (?: : \g<short> ){1,6} ) | (?: \g<short> : ){2} (?: : | (?: : \g<short> ){1,5} ) | (?: \g<short> : ){3}  (?: : | (?: : \g<short> ){1,4} ) | (?: \g<short> : ){4} (?: : | (?: : \g<short> ){1,3} ) | (?: \g<short> : ){5} (?: : | (?: : \g<short> ){1,2} ) | (?: \g<short> : ){6} (?: : | (?: : \g<short> ) ) | (?: \g<short> : ){7} : ) | (?: (?: \g<short> : ){6} \g<ipv4> | (?: \g<short> : ){5} : \g<ipv4> | (?: \g<short> : ){4} (?: : \g<short> )? : \g<ipv4> | (?: \g<short> : ){3} (?: : \g<short> ){0,2} : \g<ipv4> | (?: \g<short> : ){2} (?: : \g<short> ){0,3} : \g<ipv4> | \g<short> : (?: : \g<short> ){0,4} : \g<ipv4> | : (?: : \g<short> ){0,5} : \g<ipv4> ) ) \] )? (?: : (?: [1-9][0-9]{0,3} | [1-5][0-9]{4} | 6[0-4][0-9]{3} | 65[0-4][0-9]{2} | 655[0-2][0-9] | 6553[0-5] ) )? \/? $/]`

### `Bodgitlib::LDAP::URI::Simple`

The Bodgitlib::LDAP::URI::Simple data type.

* **Since** 1.6.0

Alias of `Variant[Bodgitlib::LDAP::URI::LDAP::Simple, Bodgitlib::LDAP::URI::LDAPS::Simple, Bodgitlib::LDAP::URI::LDAPI::Simple]`

### `Bodgitlib::Netmask`

The Bodgitlib::Netmask data type.

* **Since** 1.6.0

Alias of `Pattern[/(?x) ^ (?: 25[24] | 24[08] | 224 | 192 | 128 | 0 ) (?: \. 0 ){3} $/, /(?x) ^ 255 \. (?: 25[24] | 24[08] | 224 | 192 | 128 | 0 ) (?: \. 0 ){2} $/, /(?x) ^ (?: 255 \. ){2} (?: 25[24] | 24[08] | 224 | 192 | 128 | 0 ) \. 0 $/, /(?x) ^ (?: 255 \. ){3} (?: 255 | 25[24] | 24[08] | 224 | 192 | 128 | 0 ) $/]`

### `Bodgitlib::Port`

The Bodgitlib::Port data type.

* **Since** 1.6.0

Alias of `Variant[Bodgitlib::Port::Privileged, Bodgitlib::Port::Registered, Bodgitlib::Port::Ephemeral]`

### `Bodgitlib::Port::Ephemeral`

The Bodgitlib::Port::Ephemeral data type.

* **Since** 1.6.0

Alias of `Integer[49152, 65535]`

### `Bodgitlib::Port::Privileged`

The Bodgitlib::Port::Privileged data type.

* **Since** 1.6.0

Alias of `Integer[0, 1023]`

### `Bodgitlib::Port::Registered`

The Bodgitlib::Port::Registered data type.

* **Since** 1.6.0

Alias of `Integer[1024, 49151]`

### `Bodgitlib::Zone`

The Bodgitlib::Zone data type.

* **Since** 1.8.0

Alias of `Variant[Bodgitlib::Zone::Root, Bodgitlib::Zone::NonRoot]`

### `Bodgitlib::Zone::NonRoot`

The Bodgitlib::Zone::NonRoot data type.

* **Since** 1.8.1

Alias of `Pattern[/(?x) ^ (?= [a-z0-9.-]{2,255} ) ( (?= [a-z0-9-]{1,63} \. ) [a-z0-9]+ ( - [a-z0-9]+ )* \. )* [a-z]{2,63} \. $/]`

### `Bodgitlib::Zone::Root`

The Bodgitlib::Zone::Root data type.

* **Since** 1.8.1

Alias of `Enum['.']`

